dnl libmtmex.m4 --- a Libtool library for building Matlab MEX-files.
dnl
dnl Copyright (C) 2002, 2003 Ralph Schleicher
dnl
dnl This program is free software; you can redistribute it and/or
dnl modify it under the terms of the GNU General Public License as
dnl published by the Free Software Foundation; either version 2,
dnl or (at your option) any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; see the file COPYING.  If not, write to
dnl the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
dnl Boston, MA 02111-1307, USA.
dnl
dnl As a special exception to the GNU General Public License, if
dnl you distribute this file as part of a program that contains a
dnl configuration script generated by GNU Autoconf, you may include
dnl it under the same distribution terms that you use for the rest
dnl of that program.
dnl
dnl Code:

# _AX_LIBMTMEX_SETUP
# ------------------
# Check requirements.
AC_DEFUN([_AX_LIBMTMEX_SETUP],
[dnl
AC_PREREQ([2.50])
AC_REQUIRE([AC_PROG_CC])
AC_REQUIRE([AC_LIBTOOL_RC])
AC_REQUIRE([AC_LIBTOOL_WIN32_DLL])
AC_REQUIRE([AC_PROG_LIBTOOL])
AC_REQUIRE([_AX_MEXTOOL_PROG_WINDRES])
AC_REQUIRE([_AX_MEXTOOL_PROG_DLLTOOL])
AC_REQUIRE([_AX_MEXTOOL_MATLAB_VERSION])
AC_REQUIRE([AX_MATLAB_ARCH])
])

# _AX_LIBMTMEX_IMPLIB
# -------------------
# Check whether to build Matlab import libraries.
AC_DEFUN([_AX_LIBMTMEX_IMPLIB],
[dnl
AC_MSG_CHECKING([whether to build Matlab import libraries])
case $MATLAB_ARCH in
  win32)
    case $MATLAB_VERSION in
      5.*)
        LIBMTMEX_IMPLIB='libmatlab.a libmx.a libmat.a libeng.a'
        ;;
      *)
        LIBMTMEX_IMPLIB='libmex.a libmx.a libmat.a libeng.a'
        ;;
    esac
    ans=yes
    ;;
  *)
    LIBMTMEX_IMPLIB=
    ans=no
    ;;
esac
AC_MSG_RESULT([$ans])
AC_SUBST([LIBMTMEX_IMPLIB])
])

# _AX_LIBMTMEX_LIBM
# -----------------
# Check for math library.
AC_DEFUN([_AX_LIBMTMEX_LIBM],
[dnl
AC_REQUIRE([AC_CANONICAL_HOST])
case $host in
  *-cygwin* | *-mingw*)
    LIBMTMEX_LIBM=
    ;;
  *)
    AC_CHECK_LIB([m], [pow], [LIBMTMEX_LIBM=-lm], [LIBMTMEX_LIBM=])
    ;;
esac
AC_SUBST([LIBMTMEX_LIBM])
])

# _AX_LIBMTMEX_LIBMEX
# -------------------
# Check for MEX-file libraries.
AC_DEFUN([_AX_LIBMTMEX_LIBMEX],
[dnl
AC_MSG_CHECKING([for MEX-file libraries])
case $MATLAB_ARCH in
  win32)
    # Link against import libraries.
    case $MATLAB_VERSION in
      5.*)
	LIBMTMEX_LIBMEX='-L$(top_builddir) -lmx -lmatlab'
	;;
      *)
	LIBMTMEX_LIBMEX='-L$(top_builddir) -lmex -lmx'
	;;
    esac
    ;;
  *)
    # Link against actual libraries.
    case $MATLAB_VERSION in
      5.*)
	LIBMTMEX_LIBMEX='-L$(MATLAB)/extern/lib/$(MATLAB_ARCH) -lmx'
	;;
      *)
	LIBMTMEX_LIBMEX='-L$(MATLAB)/bin/$(MATLAB_ARCH) -lmex -lmx'
	;;
    esac
    ;;
esac
AC_MSG_RESULT([$LIBMTMEX_LIBMEX])
AC_SUBST([LIBMTMEX_LIBMEX])
])

# _AX_LIBMTMEX_WIN32
# ------------------
# Define LIBMTMEX_WIN32 Automake conditional.
AC_DEFUN([_AX_LIBMTMEX_WIN32],
[dnl
AM_CONDITIONAL([LIBMTMEX_WIN32], [test "X$MATLAB_ARCH" = Xwin32])
])

# AX_LIB_LIBMTMEX
# ---------------
AC_DEFUN([AX_LIB_LIBMTMEX],
[dnl
AC_REQUIRE([_AX_LIBMTMEX_SETUP])
AC_REQUIRE([_AX_LIBMTMEX_IMPLIB])
AC_REQUIRE([_AX_LIBMTMEX_LIBM])
AC_REQUIRE([_AX_LIBMTMEX_LIBMEX])
AC_REQUIRE([_AX_LIBMTMEX_WIN32])
])

dnl libmtmex.m4 ends here
