dnl mextool.m4 --- create shell script for building Matlab MEX-files.
dnl
dnl Copyright (C) 2002, 2003 Ralph Schleicher
dnl
dnl This program is free software; you can redistribute it and/or
dnl modify it under the terms of the GNU General Public License as
dnl published by the Free Software Foundation; either version 2,
dnl or (at your option) any later version.
dnl
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; see the file COPYING.  If not, write to
dnl the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
dnl Boston, MA 02111-1307, USA.
dnl
dnl As a special exception to the GNU General Public License, if
dnl you distribute this file as part of a program that contains a
dnl configuration script generated by GNU Autoconf, you may include
dnl it under the same distribution terms that you use for the rest
dnl of that program.
dnl
dnl Code:

# _AX_MEXTOOL_PROG_WINDRES
# ------------------------
# Check for windres.
AC_DEFUN([_AX_MEXTOOL_PROG_WINDRES],
[dnl
AC_CHECK_TOOL([WINDRES], [windres], [false])
])

# _AX_MEXTOOL_PROG_DLLTOOL
# ------------------------
# Check for dlltool.
AC_DEFUN([_AX_MEXTOOL_PROG_DLLTOOL],
[dnl
AC_CHECK_TOOL([DLLTOOL], [dlltool], [false])
])

# _AX_MEXTOOL_MATLAB_VERSION
# --------------------------
# Check for Matlab version.
AC_DEFUN([_AX_MEXTOOL_MATLAB_VERSION],
[dnl
AX_REQUIRE_MATLAB_VERSION([5])
])

# _AX_MEXTOOL_SETUP
# -----------------
# Check requirements.
AC_DEFUN([_AX_MEXTOOL_SETUP],
[dnl
AC_PREREQ([2.50])
AC_BEFORE([AX_PATH_MEX])
AC_REQUIRE([AC_PROG_CC])
AC_REQUIRE([AC_PROG_LN_S])
AC_REQUIRE([AC_PROG_LIBTOOL])
AC_REQUIRE([_AX_MEXTOOL_MATLAB_VERSION])
AC_REQUIRE([AX_MATLAB_ARCH])
AC_REQUIRE([AX_MATLAB_DIR])
])

# AX_PROG_MEXTOOL
# ---------------
# Create shell script for building Matlab MEX-files.
AC_DEFUN([AX_PROG_MEXTOOL],
[dnl
AC_REQUIRE([_AX_MEXTOOL_SETUP])

# Save prefix variables and initialize them.
mt_save_prefix=$prefix
if test "x$prefix" = xNONE ; then
    prefix=$ac_default_prefix
fi
mt_save_exec_prefix=$exec_prefix
if test "x$exec_prefix" = xNONE ; then
    exec_prefix=$prefix
fi

##
## Make file variables.
##

MEXTOOL='$(SHELL) $(top_builddir)/mextool'
AC_SUBST([MEXTOOL])

##
## Output file variables.
##

# Input file name.
mt_mtmain_sh="$ac_aux_dir/mtmain.sh"

# Output file name.
mt_mextool="mextool"

# Installation directory for Matlab MEX-files.  Recursively expand
# value of $matlabarchdir variable (must use double brackets due to
# M4 quoting).
mt_matlabarchdir="$matlabarchdir"
while echo "$mt_matlabarchdir" | grep '\$[[({]]' > /dev/null 2>&1 ; do
    mt_tem=`echo "$mt_matlabarchdir" | tr '()' '{}'`
    eval "mt_matlabarchdir=\"$mt_tem\""
done

# Absolute file name of the top-level source and build directory.
mt_top_srcdir=`cd "$ac_dir" && pwd`
mt_top_builddir=`pwd`

##
## Create output file.
##

AC_MSG_NOTICE([creating $mt_mextool])

sed \
-e "1i\\
#! $SHELL\\
" \
-e "/^#-#-#-#-#-#-#-#-/c\\
# Shell for running shell scripts.\\
SHELL='$SHELL'\\
\\
# Hard or soft links.\\
LN_S='$LN_S'\\
\\
# C preprocessor.\\
CPP='$CPP'\\
\\
# C preprocessor flags.\\
CPPFLAGS='$CPPFLAGS'\\
\\
# C compiler.\\
CC='$CC'\\
\\
# C compiler flags.\\
CFLAGS='$CFLAGS'\\
\\
# C++ compiler.\\
CXX='$CXX'\\
\\
# C++ compiler flags.\\
CXXFLAGS='$CXXFLAGS'\\
\\
# Fortran 77 compiler.\\
F77='$F77'\\
\\
# Fortran 77 compiler flags.\\
FFLAGS='$FFLAGS'\\
\\
# Linker flags.\\
LDFLAGS='$LDFLAGS'\\
\\
# Linker arguments.\\
LDADD='$LDADD'\\
\\
# Top-level Matlab installation directory.\\
MATLAB='$MATLAB'\\
\\
# Matlab version number.\\
MATLAB_VERSION='$MATLAB_VERSION'\\
\\
# Matlab machine architecture.\\
MATLAB_ARCH='$MATLAB_ARCH'\\
\\
# Directory for Matlab machine architecture dependent files.\\
matlabarchdir='$mt_matlabarchdir'\\
\\
# Libtool shell script.\\
libtool='$mt_top_builddir/libtool'\\
\\
# Libtool convenience library for building Matlab MEX-files.\\
libmtmex='$mt_top_builddir/libmtmex/libmtmex.la'\\
\\
# List of exported symbol names.\\
exports='$mt_top_builddir/libmtmex/mex-file.exp'" \
"$mt_mtmain_sh" > "$mt_mextool"
chmod +x "$mt_mextool"

##
## Cleanup.
##

# Restore prefix variables.
prefix=$mt_save_prefix
exec_prefix=$mt_save_exec_prefix

# Prevent multiple expansion.
define([AX_PROG_MEXTOOL], [])
])

dnl mextool.m4 ends here
